      PROGRAM myshiftpars
      IMPLICIT NONE
      DOUBLE PRECISION PI,localtol
      PARAMETER (PI=3.14159265358979323846)
      PARAMETER (localtol=1D-16)
      DOUBLE PRECISION a,b,alpha,tol,k,kprime,m,cK,c2,v,phi
      DOUBLE PRECISION DN,ELLIPKE,F,DLAMCH
      DOUBLE PRECISION p(100)
      INTEGER i,J
      
      WRITE(UNIT=*, FMT=*) 'Enter the lower eigenvalue bound:'
      READ(UNIT=*, FMT=*) a
      WRITE(UNIT=*, FMT=*) 'Enter the upper eigenvalue bound:'
      READ(UNIT=*, FMT=*) b
      WRITE(UNIT=*, FMT=*) 'Enter the maximum ratio of Im(lambda)/Re(lambda)
     +  for the eigenvalues :' 
      READ(UNIT=*, FMT=*) alpha
      WRITE(UNIT=*, FMT=*) 'Enter a Tolerance:'
      READ(UNIT=*, FMT=*) tol
      
      IF (alpha.EQ.0.0D0) THEN
        kprime = a/b
      ELSE
        c2=2.0D0/(1.0D0+(a/b+b/a)/2)
        m =2.0D0*DCOS(alpha)*DCOS(alpha)/c2 - 1.0D0
        IF (m .LT. 1.0D0) THEN
          STOP 'Parameters would be complex.\n 
     +     Please check your input data !\n Exiting.\n'
        END IF
        kprime=1.0D0 / (m+DSQRT(m*m-1.0D0))
      END IF  
      k = MIN(1.0D0-DLAMCH('E'),DSQRT(1.0D0-kprime*kprime))
      cK = ELLIPKE(k,localtol)
      IF (alpha.EQ.0.0D0) THEN
        v = ELLIPKE(kprime,localtol)
      ELSE
        phi=DASIN(DSQRT(a/(b*kprime)))
        v = F(phi,kprime,localtol);
      END IF
      J = INT(cK/(2*v*PI)*DLOG(4/tol))+1
      WRITE(*,*) '\n\n J=',J,'\n v=',v,'\n k=',k,'\n K=',cK,
     +     '\n kprime=',kprime,'\n\n'
      IF (J .GT. 100) THEN
        STOP 'Tolerance would result in more than 100 shifts. 
     +       \nExiting!'
      END IF
      DO 10,i=1,J
        p(i) = -DSQRT(a*b/kprime)*DN((DFLOAT(i)-0.5)*cK/J,k)
        WRITE(*,*) 'p(',i,')=',p(i)
 10   CONTINUE
      END
C      
C     Declaration of the helper functions
C
      DOUBLE PRECISION FUNCTION DN(u,k)
      IMPLICIT NONE
      DOUBLE PRECISION PI
      PARAMETER (PI=3.14159265358979323846)
      DOUBLE PRECISION u,k,phi1,phi0
      DOUBLE PRECISION a(100),b(100),c(100)
      DOUBLE PRECISION DLAMCH
      INTEGER i,j
      a(1)=1.0D0
      c(1)=k
      b(1)=MIN(1.0D0-DLAMCH('E'),DSQRT(1.0D0-k*k))
      i=1
      DO WHILE (DABS(c(i)).GT.(1E-16))
        i=i+1
        a(i)=(a(i-1)+b(i-1))/2
        b(i)=DSQRT(a(i-1)*b(i-1))
        c(i)=(a(i-1)-b(i-1))/2
      ENDDO
      phi1=DEXP(DFLOAT(i-1)*DLOG(DFLOAT(2)))*a(i)*u
      phi0=0.0
      j=i
      DO WHILE (j.GT.1)
        IF (j.LT.i) THEN
          phi1=phi0
        END IF
        phi0=(phi1+DASIN(c(j)*DSIN(phi1)/a(j)))/2
        j=j-1
      ENDDO
      IF ((1D0-k).LT.1D-5) THEN
        DN=DCOS(phi0)/DCOS(phi1-phi0)
      ELSE
        DN=DSQRT(1.0-k*k*DSIN(phi0)*DSIN(phi0))
      ENDIF
      END
      
      DOUBLE PRECISION FUNCTION ELLIPKE(k,TOL)
      IMPLICIT NONE
      DOUBLE PRECISION PI
      PARAMETER (PI=3.14159265358979323846)
      DOUBLE PRECISION a0,a1,b0,b1,s0,c1,w1,k,TOL
      DOUBLE PRECISION DLAMCH
      INTEGER i,i1
      a0=1
      b0=MIN(1-DLAMCH('E'),DSQRT(1D0-k*k))
      i1=0
      c1=1d0
      DO WHILE (c1.GT.TOL)
        a1=(a0+b0)/2
        b1=DSQRT(a0*b0)
        c1=(a0-b0)/2
        i1=i1+1
        a0=a1
        b0=b1
      ENDDO
      ELLIPKE=PI/(2*a1)
      END

      DOUBLE PRECISION FUNCTION F(phi,k,TOL)
      IMPLICIT NONE
      DOUBLE PRECISION PI
      PARAMETER (PI=3.14159265358979323846)
      DOUBLE PRECISION a0,a1,b0,b1,c1,k,TOL,phi_temp,phi,fac
      DOUBLE PRECISION DLAMCH
      INTEGER i,i1
      a0=1
      b0=MIN(1-DLAMCH('E'),DSQRT(1D0-k*k))
      i1=0
      c1=1d0
      fac=1.0D0;
      DO WHILE (c1.GT.TOL)
        a1=(a0+b0)/2
        b1=DSQRT(a0*b0)
        c1=(a0-b0)/2
        fac=fac*2.0D0
        phi_temp=phi+DATAN((b0/a0)*DTAN(phi))
        phi = phi_temp + PI*INT(phi_temp/PI+.5D0)
        i1=i1+1
        a0=a1
        b0=b1
      ENDDO
      F=phi/(fac*a1)
      END
